/**************************************************************************
* MEMACCSS.PRG                                                            *
*       Simple program to test the amount of time to access different     *
*       types of mem vars (Static, Local, Private, Public and Array       *
*       for Clipper 5.xx.                                                 *
* Author: Rod Cushman                                                     *
* CIS # : 71212,1243                                                      *
* Revision History:                                                       *
* 07/10/93 07:52pm      Rod     Created function.                         *
* 07/10/93 09:00pm      Rod     Last Revision Date...                     *
**************************************************************************/
  
  STATIC  mnStatic := 10000
  LOCAL   nCntr , nBegSec, nLocal, nTmp
  
  PRIVATE nPrivate, nArray[10], nTmp1, cTmp
  PUBLIC  nPublic
  
  nLocal   := 10000
  nPrivate := 10000
  nPublic  := 10000
  nStatic  := 10000
  nArray   := { 10000, 10000, 10000, 10000, 10000 }

  // Clear the screen
  Scroll( 0, 0, MaxRow(), MaxCol(), 0)
  
  @  2,24 Say "CLIPPER 5.xx Memory Access times:"

  @  3,50 Say "NORMAL"
  @  3,71 Say "MACRO"
  
  @  4,10 Say "Empty loop                           :"
  Memory(-1)                            // Flush Memory
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
  NEXT
  @  4,50 Say SECONDS() - nBegSec Picture "999.99"

  
  @  5,10 Say "Access of 10,000 Locals              : "
  Memory(-1)                            // Flush Memory
  nLocal  := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nLocal++
  NEXT
  @  5,50 Say SECONDS() - nBegSec Picture "999.99"

  
  @  6,10 Say "Access of 10,000 Statics             : "
  Memory(-1)                            // Flush Memory
  nStatic := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nStatic++
  NEXT
  @  6,50 Say SECONDS() - nBegSec Picture "999.99"
  

  @  7,10 Say "Access of 10,000 Privates            : "
  Memory(-1)                            // Flush Memory
  nPrivate := 0
  nBegSec  := SECONDS()
  FOR nCntr = 1 TO 10000
     nPrivate++
  NEXT
  @  7,50 Say SECONDS() - nBegSec Picture "999.99"
  
  
  @  8,10 Say "Access of 10,000 Publics             : "
  Memory(-1)                            // Flush Memory
  nPublic := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nPublic++
  NEXT
  @  8,50 Say SECONDS() - nBegSec Picture "999.99"
  
  
  @  9,10 Say "Access of 10,000 Array Elements      : "
  Memory(-1)                            // Flush Memory
  nArray  := { 0, 0, 0, 0, 0 }
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nArray[5]++
  NEXT
  @  9,50 Say SECONDS() - nBegSec Picture "999.99"


  //
  // Assignment loops
  //

 
  @ 10,10 Say "Assignment of 10,000 Locals          : "
  Memory(-1)                            // Flush Memory
  nLocal  := 10000
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nLocal := 10000
  NEXT
  @ 10,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 11,10 Say "Assignment of 10,000 Statics         : "
  Memory(-1)                            // Flush Memory
  nStatic := 10000
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nStatic := 10000
  NEXT
  @ 11,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 12,10 Say "Assignment of 10,000 Privates        : "
  Memory(-1)                            // Flush Memory
  nPrivate := 10000
  nBegSec  := SECONDS()
  FOR nCntr = 1 TO 10000
     nPrivate := 10000
  NEXT
  @ 12,50 Say SECONDS() - nBegSec Picture "999.99"

 
  @ 13,10 Say "Assignment of 10,000 Publics         : "
  Memory(-1)                            // Flush Memory
  nPublic := 10000
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nPublic := 10000
  NEXT
  @ 13,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 14,10 Say "Assignment of 10,000 Array Elements  : "
  Memory(-1)                            // Flush Memory
  nArray  := { 10000, 10000, 10000, 10000, 10000 }
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     nArray[5] := 10000
  NEXT
  @ 14,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 15,10 Say "Loop of 10,000 Local Counters        : "
  Memory(-1)                            // Flush Memory
  nLocal  := 0
  nTmp    := 0
  nBegSec := SECONDS()
  FOR nLocal = 1 TO 10000
     nTmp++
  NEXT
  @ 15,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 16,10 Say "Loop of 10,000 Static Counters       : "
  Memory(-1)                            // Flush Memory
  nStatic := 0
  nTmp    := 0
  nBegSec := SECONDS()
  FOR nStatic = 1 TO 10000
     nTmp++
  NEXT
  @ 16,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 17,10 Say "Loop of 10,000 Private Counters      : "
  Memory(-1)                            // Flush Memory
  nPrivate := 0
  nTmp     := 0
  nBegSec  := SECONDS()
  FOR nPrivate = 1 TO 10000
     nTmp++
  NEXT
  @ 17,50 Say SECONDS() - nBegSec Picture "999.99"

  
  @ 18,10 Say "Loop of 10,000 Public Counters       : "
  Memory(-1)                            // Flush Memory
  nPublic := 0
  nTmp    := 0
  nBegSec := SECONDS()
  FOR nPublic = 1 TO 10000
     nTmp++
  NEXT
  @ 18,50 Say SECONDS() - nBegSec Picture "999.99"


  @ 19,10 Say "Loop of 10,000 Array Element Counters: "
  Memory(-1)                            // Flush Memory
  nArray  := { 0, 0, 0, 0, 0 }
  nTmp    := 0
  nBegSec := SECONDS()
  FOR nArray[5] = 1 TO 10000
     nTmp++
  NEXT
  @ 19,50 Say SECONDS() - nBegSec Picture "999.99"


  //
  // Macro-evaluate loops
  //
  
* @  5,10 Say "Access of 10,000 Locals              : "
  Memory(-1)                            // Flush Memory
  cLocal  := "nTmp1"
  nTmp1   := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &cLocal.++
  NEXT
  @  5,70 Say SECONDS() - nBegSec Picture "999.99"

  
* @  6,10 Say "Access of 10,000 Statics             : "
  Memory(-1)                            // Flush Memory
  cStatic := "nTmp1"
  nTmp1   := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &cStatic.++
  NEXT
  @  6,70 Say SECONDS() - nBegSec Picture "999.99"
  

* @  7,10 Say "Access of 10,000 Privates            : "
  Memory(-1)                            // Flush Memory
  cPrivate := "nTmp1"
  nTmp1   := 1
  nBegSec  := SECONDS()
  FOR nCntr = 1 TO 10000
     &cPrivate.++
  NEXT
  @  7,70 Say SECONDS() - nBegSec Picture "999.99"
  
  
* @  8,10 Say "Access of 10,000 Publics             : "
  Memory(-1)                            // Flush Memory
  cPublic := "nTmp1"
  nTmp1   := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &cPublic.++
  NEXT
  @  8,70 Say SECONDS() - nBegSec Picture "999.99"
  
  
* @  9,10 Say "Access of 10,000 Array Elements      : "
  Memory(-1)                            // Flush Memory
  cArray  := { "nTmp1", "nTmp1", "nTmp1", "nTmp1", "nTmp1" }
  nTmp1   := 1
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &(cArray[5])++
  NEXT
  @  9,70 Say SECONDS() - nBegSec Picture "999.99"


  //
  // Assignment loops
  //

 
* @ 10,10 Say "Assignment of 10,000 Locals          : "
  Memory(-1)                            // Flush Memory
  cLocal  := "nTmp1"
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &cLocal. := 10000
  NEXT
  @ 10,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 11,10 Say "Assignment of 10,000 Statics         : "
  Memory(-1)                            // Flush Memory
  cStatic := "nTmp1"
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &cStatic. := 10000
  NEXT
  @ 11,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 12,10 Say "Assignment of 10,000 Privates        : "
  Memory(-1)                            // Flush Memory
  cPrivate := "nTmp1"
  nBegSec  := SECONDS()
  FOR nCntr = 1 TO 10000
     &cPrivate. := 10000
  NEXT
  @ 12,70 Say SECONDS() - nBegSec Picture "999.99"

 
* @ 13,10 Say "Assignment of 10,000 Publics         : "
  Memory(-1)                            // Flush Memory
  cPublic := "nTmp1"
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &cPublic. := 10000
  NEXT
  @ 13,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 14,10 Say "Assignment of 10,000 Array Elements  : "
  Memory(-1)                            // Flush Memory
  cArray  := { "nTmp1", "nTmp1", "nTmp1", "nTmp1", "nTmp1" }
  nBegSec := SECONDS()
  FOR nCntr = 1 TO 10000
     &(cArray[5]) := 10000
  NEXT
  @ 14,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 15,10 Say "Loop of 10,000 Local Counters        : "
  Memory(-1)                            // Flush Memory
  cLocal  := "nTmp1"
  nTmp    := 0
  nBegSec := SECONDS()
  FOR &cLocal. = 1 TO 10000
     nTmp++
  NEXT
  @ 15,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 16,10 Say "Loop of 10,000 Static Counters       : "
  Memory(-1)                            // Flush Memory
  cStatic := "nTmp1"
  nTmp    := 0
  nBegSec := SECONDS()
  FOR &cStatic. = 1 TO 10000
     nTmp++
  NEXT
  @ 16,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 17,10 Say "Loop of 10,000 Private Counters      : "
  Memory(-1)                            // Flush Memory
  cPrivate := "nTmp1"
  nTmp     := 0
  nBegSec  := SECONDS()
  FOR &cPrivate. = 1 TO 10000
     nTmp++
  NEXT
  @ 17,70 Say SECONDS() - nBegSec Picture "999.99"

  
* @ 18,10 Say "Loop of 10,000 Public Counters       : "
  Memory(-1)                            // Flush Memory
  cPublic := "nTmp1"
  nTmp    := 0
  nBegSec := SECONDS()
  FOR &cPublic. = 1 TO 10000
     nTmp++
  NEXT
  @ 18,70 Say SECONDS() - nBegSec Picture "999.99"


* @ 19,10 Say "Loop of 10,000 Array Element Counters: "
  Memory(-1)                            // Flush Memory
  cArray  := { "nTmp1", "nTmp1", "nTmp1", "nTmp1", "nTmp1" }
  nTmp    := 0
  nBegSec := SECONDS()
  FOR &(cArray[5]) = 1 TO 10000
     nTmp++
  NEXT
  @ 19,70 Say SECONDS() - nBegSec Picture "999.99"
Return
